unit About;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, ShellAPI;

type
  TAbout_Frm = class(TForm)
    OKButton: TButton;
    Bevel1: TBevel;
    PhysMem: TLabel;
    Label3: TLabel;
    OS: TLabel;
    Banner_Lbl: TLabel;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    httpLabel: TLabel;
    emailLabel: TLabel;
    procedure OKButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure httpLabelClick(Sender: TObject);
    procedure emailLabelClick(Sender: TObject);
    procedure OKButtonKeyPress(Sender: TObject; var Key: Char);
  private
    procedure GetOSInfo;
    procedure InitializeCaptions;
  end;

procedure ShowAboutBox;

var
  About_Frm : TAbout_Frm;
  cKeyPress : string;

implementation

uses Main, Procs, Pooh;

{$R *.DFM}

procedure ShowAboutBox;
begin
  with TAbout_Frm.Create(Application) do
    try
      ShowModal;
    finally
      Free;
    end;
end;



procedure TAbout_Frm.GetOSInfo;
var
  Platform    : string;
  BuildNumber : integer;
begin
  case Win32Platform of
    VER_PLATFORM_WIN32_WINDOWS:
      begin
        Platform := 'Windows 95/98';
        BuildNumber := Win32BuildNumber and $0000FFFF;
      end;
    VER_PLATFORM_WIN32_NT:
      begin
        Platform := 'Windows NT';
        BuildNumber := Win32BuildNumber;
      end;
      else
      begin
        Platform := 'Windows';
        BuildNumber := 0;
      end;
  end;

  if (Win32Platform = VER_PLATFORM_WIN32_WINDOWS) or
    (Win32Platform = VER_PLATFORM_WIN32_NT) then
  begin
    if Win32CSDVersion = '' then
      OS.Caption := Format('%s %d.%d (Build %d)',[Platform,Win32MajorVersion,
        Win32MinorVersion,BuildNumber])
    else
      OS.Caption := Format('%s %d.%d (Build %d: %s)',[Platform,Win32MajorVersion,
        Win32MinorVersion,BuildNumber,Win32CSDVersion]);
  end
  else
    OS.Caption := Format('%s %d.%d',[Platform,Win32MajorVersion,
      Win32MinorVersion])
end;



procedure TAbout_Frm.InitializeCaptions;
var
  MS : TMemoryStatus;
begin
  Label1.Caption := VERNO;
  GetOSInfo;
  MS.dwLength := SizeOf(TMemoryStatus);
  GlobalMemoryStatus(MS);
  PhysMem.Caption := FormatFloat('#,###" KB"',MS.dwTotalPhys div 1024);
end;



procedure TAbout_Frm.OKButtonClick(Sender: TObject);
begin
  Main_Frm.Enabled := True;
  Close;
end;



procedure TAbout_Frm.FormShow(Sender: TObject);
begin
  InitializeCaptions;
  cKeyPress := '';
end;



{ Open default browser and goto Concilium Orb Website }
procedure TAbout_Frm.httpLabelClick(Sender: TObject);
begin
  ExecuteFile('http://www.nrgsys.com/orb/','','', SW_SHOWNORMAL);
end;



{ email me }
procedure TAbout_Frm.emailLabelClick(Sender: TObject);
begin
  ExecuteFile('mailto:jonh@eircom.net?subject=TagFactory '+VERNO, '','',SW_SHOWNORMAL);
end;



{ The hidden Pooh Screen }
procedure TAbout_Frm.OKButtonKeyPress(Sender: TObject; var Key: Char);
begin
  // What keys have been pressed?
  cKeyPress := UpperCase(StrRight(cKeyPress + Key,4));
  if cKeyPress = 'POOH' then Pooh_Frm.Show;
end;



end.
