unit Config;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TConfig_Frm = class(TForm)
    Tag_Edt: TEdit;
    Back_Edt: TEdit;
    Dump_Edt: TEdit;
    Edit_Edt: TEdit;
    Line_Edt: TEdit;
    MaxLen_Edt: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Split_Chk: TCheckBox;
    Avery_Chk: TCheckBox;
    Save_Btn: TBitBtn;
    Canc_Btn: TBitBtn;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Srch_List: TMemo;
    Repl_List: TMemo;
    procedure FormShow(Sender: TObject);
    procedure Canc_BtnClick(Sender: TObject);
    procedure Save_BtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Config_Frm: TConfig_Frm;

implementation

uses Main;
{$R *.DFM}


{ Show current settings }
procedure TConfig_Frm.FormShow(Sender: TObject);
begin
  Config_Frm.Caption := 'TagFactory '+VERNO+' Configuration';

  if lDefFile = True then Tag_Edt.Text := UpperCase(cDefFile)
  else Tag_Edt.Text := UpperCase(Main_Frm.OpenDialog.FileName);
  Back_Edt.Text     := UpperCase(cBakFile);
  Dump_Edt.Text     := UpperCase(cDefDump);
  Edit_Edt.Text     := UpperCase(cEditor);
  Line_Edt.Text     := IntToStr(iLines);
  MaxLen_Edt.Text   := IntToStr(iMaxLen);

  Srch_List.Lines   := liSearch;
  Repl_List.Lines   := liReplace;

  if lSplit = True then Split_Chk.Checked := True
  else Split_Chk.Checked := False;

  if lAvery = True then Avery_Chk.Checked := True
  else Avery_Chk.Checked := False;
end;


{ Cancel Config }
procedure TConfig_Frm.Canc_BtnClick(Sender: TObject);
begin
  Main_Frm.Show;
  Config_Frm.Hide;
end;


{ Save new settings }
procedure TConfig_Frm.Save_BtnClick(Sender: TObject);
var
  n : integer;                  // Counter used for stringlists
begin
  // A backup file must be specified
  if Back_Edt.Text = '' then
    begin
      MessageDlg('No Backup File Specified!  Unable To Save Settings.',
           mtError,[mbOK],0);
      Exit;
    end;

  IniFile.WriteString('Defaults','TagFile',Tag_Edt.Text);
  IniFile.WriteString('Backup','BackupFile',Back_Edt.Text);
  IniFile.WriteString('Defaults','DumpFile',Dump_Edt.Text);
  IniFile.WriteString('Preferences','Editor',Edit_Edt.Text);
  IniFile.WriteInteger('Preferences','SplitLines',StrToInt(Line_Edt.Text));
  IniFile.WriteInteger('Preferences','MaxLength',StrToInt(MaxLen_Edt.Text));

  // write back search strings
  n := 1;
  while n <= Srch_List.Lines.Count do
    begin
      IniFile.WriteString('Search','Search'+IntToStr(n),Srch_List.Lines.Strings[n - 1]);
      Inc(n);
    end;
  // Blank out any unused sections
  while n <= 30 do
    begin
      IniFile.WriteString('Search','Search'+IntToStr(n),'');
      Inc(n);
    end;
  // write back replace strings
  n := 1;
  while n <= Repl_List.Lines.Count do
    begin
      IniFile.WriteString('Replace','Replace'+IntToStr(n),Repl_List.Lines.Strings[n - 1]);
      Inc(n);
    end;
  // Blank out any unused sections
  while n <= 30 do
    begin
      IniFile.WriteString('Replace','Replace'+IntToStr(n),'');
      Inc(n);
    end;

  if Split_Chk.Checked = True then
    begin
      IniFile.WriteString('Preferences','Split','True');
    end
  else
    begin
      IniFile.WriteString('Preferences','Split','False');
    end;
  if Avery_Chk.Checked = True then
    begin
      IniFile.WriteString('Preferences','AveryMarkers','True');
    end
  else
    begin
      IniFile.WriteString('Preferences','AveryMarkers','False');
    end;

  Main_Frm.Show;
  Config_Frm.Hide;
end;


end.
