unit Dump;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TDump_Frm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Dump_Edt: TEdit;
    Line_Edt: TEdit;
    GroupBox1: TGroupBox;
    Split_Chk: TCheckBox;
    Avery_Chk: TCheckBox;
    OK_Btn: TBitBtn;
    Canc_Btn: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure Canc_BtnClick(Sender: TObject);
    procedure OK_BtnClick(Sender: TObject);
    procedure Split_ChkClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Dump_Frm: TDump_Frm;

implementation

uses Main, Procs;

{$R *.DFM}


{ Setup form }
procedure TDump_Frm.FormShow(Sender: TObject);
begin
  Dump_Edt.Text := cDefDump;
  Line_Edt.Text := IntToStr(iLines);

  if lSplit = True then Split_Chk.Checked := True
  else Split_Chk.Checked := False;

  if lAvery = True then Avery_Chk.Checked := True
  else Avery_Chk.Checked := False;

  if lSplit = True then Line_Edt.Enabled := True
  else Line_Edt.Enabled := False;
end;


{ Cancel Export }
procedure TDump_Frm.Canc_BtnClick(Sender: TObject);
begin
  Main_Frm.Enabled := True;
  Dump_Frm.Close;
end;


{ Begin export }
procedure TDump_Frm.OK_BtnClick(Sender: TObject);
var
  fDumpFile   : TextFile;              // File to dump to
  iTotTags    : integer;               // How many tags we are dumping
  iSplitLimit : integer;               // How many we are splitting by
  iCount      : integer;               // used for loops
  iExt        : integer;               // Number used as file extension
begin
  Main_Frm.Status.Panels[2].Text := 'Exporting...';
  Screen.Cursor := crHourGlass;
  Dump_Frm.Close;
  if FileExists(Dump_Edt.Text) then
    begin
      if MessageDlg('Export File Already Exists!  Overwrite?',mtConfirmation,
          [mbYes,mbNo],0) = mrNo then
        begin
          Main_Frm.Status.Panels[2].Text := 'Idle';
          Screen.Cursor := crDefault;
          Main_Frm.Enabled := True;
          Exit;
        end;
    end;

  iTotTags := Main_Frm.Scr.Lines.Count;
  iCount := 0;
  iExt := 1;

  if Split_Chk.Checked = False then
    begin
      AssignFile(fDumpFile,Dump_Edt.Text);
      ReWrite(fDumpFile);
      Writeln(fDumpFile,'Created by TagFactory '+VERNO);
      Writeln(fDumpFile);
      Writeln(fDumpFile,'Searchword: "'+cKeyWord+'"');
      Writeln(fDumpFile);
      if Avery_Chk.Checked = True then Writeln(fDumpFile,'[Begin Tags]');
      while iCount < iTotTags do
        begin
          Writeln(fDumpFile,Main_Frm.Scr.Lines.Strings[iCount]);
          Inc(iCount);
        end;
      if Avery_Chk.Checked = True then Writeln(fDumpFile,'[End Tags]');
      CloseFile(fDumpFile);
      Main_Frm.Scr.Lines.Clear;
    end;

  if Split_Chk.Checked = True then
    begin
      iSplitLimit := StrToInt(Line_Edt.Text);
      while Main_Frm.Scr.Lines.Count <> 0 do
        begin
          AssignFile(fDumpFile,ChangeExt(Dump_Edt.Text,IntToStr(iExt)));
          ReWrite(fDumpFile);
          Writeln(fDumpFile,'Created by TagFactory '+VERNO);
          Writeln(fDumpFile);
          Writeln(fDumpFile,'Searchword: "'+cKeyWord+'"');
          Writeln(fDumpFile);
          if Avery_Chk.Checked = True then Writeln(fDumpFile,'[Begin Tags]');

          repeat
            Writeln(fDumpFile,Main_Frm.Scr.Lines.Strings[0]);
            Main_Frm.Scr.Lines.Delete(0);
            Inc(iCount);
          until (iCount = iSplitLimit) or (Main_Frm.Scr.Lines.Count = 0);
          if Avery_Chk.Checked = True then Writeln(fDumpFile,'[End Tags]');
          iCount := 0;
          Inc(iExt);
          CloseFile(fDumpFile);
        end;
    end;

  Main_Frm.Status.Panels[2].Text := 'Idle';
  Screen.Cursor := crDefault;
  if Split_Chk.Checked = False then MessageDlg(IntToStr(iTotTags)+' Taglines Exported!',
       mtInformation,[mbOK],0)
  else MessageDlg(IntToStr(iTotTags)+' Taglines Exported Into '+IntToStr((iExt -1))+' Files',
       mtInformation,[mbOK],0);
  Main_Frm.Enabled := True;
end;


{ Disable lines, unless we are splitting }
procedure TDump_Frm.Split_ChkClick(Sender: TObject);
begin
  if Split_Chk.Checked = True then Line_Edt.Enabled := True
  else Line_Edt.Enabled := False;
end;


end.
