unit Search;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Gauges;

type
  TSrch_Frm = class(TForm)
    Gauge: TGauge;
    Stop_Btn: TBitBtn;
    Srch_Edt: TEdit;
    Ok_Btn: TBitBtn;
    Canc_Btn: TBitBtn;
    Label1: TLabel;
    procedure Canc_BtnClick(Sender: TObject);
    procedure Ok_BtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Stop_BtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure Ready;
procedure Working;

var
  Srch_Frm : TSrch_Frm;

implementation

uses Main, Procs;

{$R *.DFM}


{ Make sure form is in ready mode to start }
procedure TSrch_Frm.FormShow(Sender: TObject);
begin
  Ready;
end;


{ Cancel Search }
procedure TSrch_Frm.Canc_BtnClick(Sender: TObject);
begin
  Main_Frm.Enabled := True;
  Srch_Frm.Close;
end;


{ The search }
procedure TSrch_Frm.Ok_BtnClick(Sender: TObject);
var
  fSearchFile : TextFile;                     // File we are searching in
  zBuf        : array[1..20*1024] of Char;    // 20k buffer
  iIsMatch    : integer;                      // Is it a match?
  cTempStr    : string;                       // Temporary string
begin
  Working;
  lSearchOk := True;

  if (Main_Frm.OpenDialog.FileName = '') and (lDefFile = False) then
    begin
      MessageDlg('No Tagline File Selected!',mtError,[mbOK],0);
      Ready;
      Exit;
    end;

  if lDefFile = True then AssignFile(fSearchFile,cDefFile)
  else AssignFile(fSearchFile,Main_Frm.OpenDialog.Filename);
  System.SetTextBuf(fSearchFile,zBuf);

  // Firstly count the tags
  if lDefFile = True then CountTags(cDefFile)
  else CountTags(Main_Frm.OpenDialog.Filename);

  // Now we search
  Reset(fSearchFile);
  Gauge.MaxValue := iTotalTags;
  cKeyWord := Srch_Edt.Text;

  while not (Eof(fSearchFile)) and (lSearchOk = True) do
    begin
      Readln(fSearchFile,cTempStr);
      iIsMatch := Pos(UpperCase(cKeyWord),UpperCase(cTempStr));
      if iIsMatch <> 0 then Main_Frm.Scr.Lines.Append(cTempStr);
      Gauge.Progress := Gauge.Progress + 1;
      Application.ProcessMessages;
    end;

  CloseFile(fSearchFile);
  MessageDlg(IntToStr(Main_Frm.Scr.Lines.Count)+' Taglines Found, Out Of '
      +IntToStr(iTotalTags),mtInformation,[mbOK],0);

  Ready;
  Main_Frm.Enabled := True;
  Srch_Frm.Close;
end;


{ Stop the search }
procedure TSrch_Frm.Stop_BtnClick(Sender: TObject);
begin
  lSearchOk := False;
  Application.ProcessMessages;
end;


{ Puts form in ready mode }
procedure Ready;
begin
  Srch_Frm.Caption := 'Search For Taglines';
  Srch_Frm.Gauge.Progress := 0;
  Main_Frm.Status.Panels[2].Text := 'Idle';
  Srch_Frm.Srch_Edt.Visible := True;
  Srch_Frm.Ok_Btn.Visible := True;
  Srch_Frm.Canc_Btn.Visible := True;
  Srch_Frm.Label1.Visible := True;
  Srch_Frm.Gauge.Visible := False;
  Srch_Frm.Stop_Btn.Visible := False;
end;


{ Puts form in working mode }
procedure Working;
begin
  Srch_Frm.Caption := 'Please Wait...';
  Main_Frm.Status.Panels[2].Text := 'Searching...';
  Srch_Frm.Srch_Edt.Visible := False;
  Srch_Frm.Ok_Btn.Visible := False;
  Srch_Frm.Canc_Btn.Visible := False;
  Srch_Frm.Label1.Visible := False;
  Srch_Frm.Gauge.Visible := True;
  Srch_Frm.Stop_Btn.Visible := True;
end;



end.
